import gleam/dynamic/decode
import gleam/json

pub type Player {
  Player(name: String, id: Int, score: Int)
}

pub fn serialize(player: Player) -> List(#(String, json.Json)) {
  [
    #("name", json.string(player.name)),
    #("id", json.int(player.id)),
    #("score", json.int(player.score)),
  ]
}

pub fn decoder() -> decode.Decoder(Player) {
  {
    use name <- decode.field("name", decode.string)
    use id <- decode.field("id", decode.int)
    use score <- decode.field("score", decode.int)
    decode.success(Player(name:, id:, score:))
  }
}
