import gleam/dynamic/decode
import gleam/json
import gleam/list
import player

pub type Session {
  Session(id: Int, host_user_id: Int, players: List(player.Player))
}

pub fn serialize(session: Session) -> json.Json {
  json.object([
    #("id", json.int(session.id)),
    #("host_user_id", json.int(session.host_user_id)),
    #(
      "players",
      json.array(
        list.map(session.players, fn(p) { player.serialize(p) }),
        of: json.object,
      ),
    ),
  ])
}

pub fn decoder() -> decode.Decoder(Session) {
  use id <- decode.field("id", decode.int)
  use host_user_id <- decode.field("host_user_id", decode.int)
  use players <- decode.field("players", decode.list(player.decoder()))

  decode.success(Session(id:, host_user_id:, players:))
}

pub fn deseralize(json_string: String) -> Result(Session, json.DecodeError) {
  json.parse(from: json_string, using: decoder())
}
